#ifndef __PROTOCOL_H__
#define __PROTOCOL_H__ 1

#include <qstring.h>
#include <kio/global.h>
#include <kio/slavebase.h>
#include "vfolder.h"
#include "desktopfile.h"

namespace VFolder {
	class VFolderProtocol: public KIO::SlaveBase
	{
	public:
		VFolderProtocol(QCString const &pool, QCString const &app);
		virtual ~VFolderProtocol();
		virtual void get(KURL const &url);
		virtual void stat(KURL const &url);
		virtual void listDir(KURL const &url);
		virtual bool checkFolder(VFolderEntry *folder);
	protected:
		void readXmlFile(QString filename="/etc/X11/desktop-menus/applications.menu");
	private:
		VFolderEntry	*root;
		DesktopFiles	*desktop;
		QString		currentXml;
	};
};
#endif
